﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Threading;
using Infragistics.Controls.Grids;
using Infragistics.DragDrop;
using Infragistics.Olap;
using Infragistics.Olap.Data;

namespace DragDropSample
{
    public partial class PivotGridDragDrop : ResourceDictionary
    {
        private void OnDragStart(object sender, DragDropStartEventArgs e)
        {
            DragSource source = sender as DragSource;

            // Need to use a dispatcher because our drag events need to happen AFTER the pivot grid drag events
            Application.Current.Dispatcher.BeginInvoke(new Action(() =>
            {
                source.DragOver += OnDragOver;
                source.DragEnd += source_DragEnd;
            }), DispatcherPriority.Background, null);
        }

        void source_DragEnd(object sender, DragDropEventArgs e)
        {
            DragSource source = sender as DragSource;
            source.DragOver -= OnDragOver;
            source.DragEnd -= source_DragEnd;
        }

        private void OnDragOver(object sender, DragDropMoveEventArgs e)
        {
            PivotPartType partType = XamPivotGrid.GetPivotPartType(e.DropTarget);
            if (partType == PivotPartType.DeleteArea)
            {
                IAreaItemViewModel areaItem = e.Data as IAreaItemViewModel;
                if (areaItem != null && !(areaItem is IKpi))
                {
                    e.DropNotAllowedCursorTemplate = this["removeItemDragCursorTemplate"] as DataTemplate;
                }
            }
        }
    }
}
